%     VIRTUAL SORIC - программа для получения эффективных свойств заполнителей SORIC
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Nset_Result = Match_Nodes(Nset, Nset_Pattern, NODES, Dim, Node_Merge_Tolerance)

global ErrCode;

Nset_Result = [];

if (numel(Nset) ~= numel(Nset_Pattern))
    fprintf (1, '\nОшибка функции Match_Nodes: размеры сэтов Nset и Nset_Pattern не совпадают!\n');
    ErrCode = -1;
    return;
end

NODES_SUBSET = zeros(size(Nset,1), 4);

for i=1:size(Nset,1)
    NODES_SUBSET(i,:) = NODES(Nset(i),:);
end

Nset_Result = zeros(size(Nset,1),1);

for i=1:size(Nset_Pattern, 1)
    
    switch Dim
        
        case 1
            
            tmp = Generate_Nset(NODES_SUBSET, NODES_SUBSET(1,2)-Node_Merge_Tolerance, NODES_SUBSET(1,2)+Node_Merge_Tolerance, ...
                                              NODES(Nset_Pattern(i),3)-Node_Merge_Tolerance, NODES(Nset_Pattern(i),3)+Node_Merge_Tolerance, ...
                                              NODES(Nset_Pattern(i),4)-Node_Merge_Tolerance, NODES(Nset_Pattern(i),4)+Node_Merge_Tolerance);
            
        case 2
            
            tmp = Generate_Nset(NODES_SUBSET, NODES(Nset_Pattern(i),2)-Node_Merge_Tolerance, NODES(Nset_Pattern(i),2)+Node_Merge_Tolerance, ...
                                              NODES_SUBSET(1,3)-Node_Merge_Tolerance, NODES_SUBSET(1,3)+Node_Merge_Tolerance, ...
                                              NODES(Nset_Pattern(i),4)-Node_Merge_Tolerance, NODES(Nset_Pattern(i),4)+Node_Merge_Tolerance);
            
        case 3
            
            tmp = Generate_Nset(NODES_SUBSET, NODES(Nset_Pattern(i),2)-Node_Merge_Tolerance, NODES(Nset_Pattern(i),2)+Node_Merge_Tolerance, ...
                                              NODES(Nset_Pattern(i),3)-Node_Merge_Tolerance, NODES(Nset_Pattern(i),3)+Node_Merge_Tolerance, ...
                                              NODES_SUBSET(1,4)-Node_Merge_Tolerance, NODES_SUBSET(1,4)+Node_Merge_Tolerance);
            
        otherwise
            
            fprintf (1, '\nОшибка функции Match_Nodes: недопустимое значение параметра Dim !\n');
            ErrCode = -1;
            return;
        
    end
    
    if (isempty(tmp))
        fprintf (1, '\nОшибка функции Match_Nodes: на противоположной грани не найдено ни одного подходящего узла (Dim = %i) !\n', Dim);
        ErrCode = -1;
        return;
    end

    if (size(tmp,1) ~= 1)
        fprintf (1, '\nОшибка функции Match_Nodes: на противоположной грани найдено более одного подходящего узла (Dim = %i) !\n', Dim);
        ErrCode = -1;
        return;
    end
    
    Nset_Result(i,1) = tmp;
    
end
